Package org.zkoss.bind.annotation

## Enum Scope

- java.lang.Object
- - java.lang.Enum<Scope>
  - - org.zkoss.bind.annotation.Scope

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<Scope>`

      public enum Scope
      extends java.lang.Enum<Scope>

  The implicit scopes of zk for `ScopeParam`.
  The AUTO scope means searching the value from components to page, desktop one bye one automatically...until find a value SESSION, APPLICATION and by the order.
  Other scope only represents itself.
  Since:
    6.0.0
  Author:
    dennis
  See Also:
    `ScopeParam`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `APPLICATION` | Search the value from the implicit applicationScope
    `AUTO` | Search the value from components to page, desktop one bye one...until find a value
    `COMPONENT` | Search the value from the implicit componentScope
    `DESKTOP` | Search the value from the implicit desktopScope
    `EXECUTION` | Search the value from the implicit executionScope
    `PAGE` | Search the value from the implicit pageScope
    `SESSION` | Search the value from the implicit sessionScope
    `SPACE` | Search the value from the implicit spaceScope

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getName()` | the zk implicit scope name
    `static Scope` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static Scope[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### AUTO

          public static final Scope AUTO

      Search the value from components to page, desktop one bye one...until find a value

    - #### COMPONENT

          public static final Scope COMPONENT

      Search the value from the implicit componentScope

    - #### SPACE

          public static final Scope SPACE

      Search the value from the implicit spaceScope

    - #### PAGE

          public static final Scope PAGE

      Search the value from the implicit pageScope

    - #### DESKTOP

          public static final Scope DESKTOP

      Search the value from the implicit desktopScope

    - #### SESSION

          public static final Scope SESSION

      Search the value from the implicit sessionScope

    - #### APPLICATION

          public static final Scope APPLICATION

      Search the value from the implicit applicationScope

    - #### EXECUTION

          public static final Scope EXECUTION

      Search the value from the implicit executionScope
      Since:
        8.6.0

  - ### Method Detail

    - #### values

          public static Scope[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Scope c : Scope.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Scope valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getName

          public java.lang.String getName()

      the zk implicit scope name